"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Organisation(ProtocolElement):
    """
    An organisation which may own or be assigned to a case
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "ods",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_6 import cva as cva_1_5_3

        return {
            "org.gel.models.cva.avro.Organisation": cva_1_5_3.Organisation,
        }

    __slots__ = [
        "ods",
        "gmc",
        "site",
    ]

    def __init__(
        self,
        ods,
        gmc=None,
        site=None,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.Organisation model.

        :param ods:
            ODS code
        :type ods: str
        :param gmc:
            The GMC name
        :type gmc: None | str
        :param site:
            The site name
        :type site: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
